searchData={"content_type":"text/markdown","items":[{"doc":"Main user-friendly functions for interacting with the endpoints of a Nominatim API.","ref":"ExNominatim.html","title":"ExNominatim","type":"module"},{"doc":"Purpose: show internal details for an OpenStreetMap object (for debugging only) using the `/details` API endpoint.\n\nNote: You can set an alternative server as the value of the `:base_url` keyword and ignore any validation errors by setting the `:force` keyword's value to `true`.\n\nGiven a keyword list of request parameters as `params`, transform this to a `%DetailsParams{}` struct, validate it and its values using the `ExNominatim.Validations` module's functions and, if valid (or if `params` contains `force: true` to ignore any validation errors), prepare and make an HTTP request to the `/details` endpoint using the functions in the `ExNominatim.HTTP` module.","ref":"ExNominatim.html#details/1","title":"ExNominatim.details/1","type":"function"},{"doc":"Given a request params struct (`%ReverseParams{}`, `%SearchParams{}`, etc.) explain its fields, their default values (if any) and their values' limits (if applicable).\n\nThe content shown is adapted from the [Nominatim API Reference](https://nominatim.org/release-docs/latest/api/Overview/) page of the endpoint corresponding to the request params struct.\n\nThe result is a map, so that you can pluck out any values if you intend to reuse them for user guidance and error reporting in your own application.","ref":"ExNominatim.html#explain_fields/1","title":"ExNominatim.explain_fields/1","type":"function"},{"doc":"Purpose: look up address details for OpenStreetMap objects by their ID using the `/lookup` API endpoint.\n\nNote: You can set an alternative server as the value of the `:base_url` keyword and ignore any validation errors by setting the `:force` keyword's value to `true`.\n\nGiven a keyword list of request parameters as `params`, transform this to a `%LookupParams{}` struct, validate it and its values using the `ExNominatim.Validations` module's functions and, if valid (or if `params` contains `force: true` to ignore any validation errors), prepare and make an HTTP request to the `/lookup` endpoint using the functions in the `ExNominatim.HTTP` module.","ref":"ExNominatim.html#lookup/1","title":"ExNominatim.lookup/1","type":"function"},{"doc":"Purpose: search OpenStreetMap objects by their location using the `/reverse` API endpoint.\n\nNote: You can set an alternative server as the value of the `:base_url` keyword and ignore any validation errors by setting the `:force` keyword's value to `true`.\n\nGiven a keyword list of request parameters as `params`, transform this to a `%ReverseParams{}` struct, validate it and its values using the `ExNominatim.Validations` module's functions and, if valid (or if `params` contains `force: true` to ignore any validation errors), prepare and make an HTTP request to the `/reverse` endpoint using the functions in the `ExNominatim.HTTP` module.","ref":"ExNominatim.html#reverse/1","title":"ExNominatim.reverse/1","type":"function"},{"doc":"Purpose: search OpenStreetMap objects by name or type using the `/search` API endpoint.\n\nNote: You can set an alternative server as the value of the `:base_url` keyword and ignore any validation errors by setting the `:force` keyword's value to `true`.\n\nGiven a keyword list of request parameters as `params`, transform this to a `%SearchParams{}` struct, validate it and its values using the `ExNominatim.Validations` module's functions and, if valid (or if `params` contains `force: true` to ignore any validation errors), prepare and make an HTTP request to the `/search` endpoint using the functions in the `ExNominatim.HTTP` module.","ref":"ExNominatim.html#search/1","title":"ExNominatim.search/1","type":"function"},{"doc":"Purpose: query the status of the server at `base_url` using the `/status` API endpoint.\n\nNote: You can set an alternative server as the value of the `:base_url` keyword and ignore any validation errors by setting the `:force` keyword's value to `true`.\n\nGiven a keyword list of request parameters as `params`, transform this to a `%StatusParams{}` struct, validate it and its values using the `ExNominatim.Validations` module's functions and, if valid (or if `params` contains `force: true` to ignore any validation errors), prepare and make an HTTP request to the `/status` endpoint using the functions in the `ExNominatim.HTTP` module.","ref":"ExNominatim.html#status/1","title":"ExNominatim.status/1","type":"function"},{"doc":"Functions used for creating a validated request and dispatching it to the requested endpoint.","ref":"ExNominatim.Client.html","title":"ExNominatim.Client","type":"module"},{"doc":"Use the `/details` API endpoint. Delegated to from `ExNominatim.details/1`, which is documented.","ref":"ExNominatim.Client.html#details/1","title":"ExNominatim.Client.details/1","type":"function"},{"doc":"Use the `/lookup` API endpoint. Delegated to from `ExNominatim.lookup/1`, which is documented.","ref":"ExNominatim.Client.html#lookup/1","title":"ExNominatim.Client.lookup/1","type":"function"},{"doc":"Create a new request params struct from the provided keyword list `p`, taking into account any required fields listed as atoms in the `required` list. Delegated to from the `new/1` function of the modules of `SearchParams`, `ReverseParams`, etc. (the `module`).","ref":"ExNominatim.Client.html#new/3","title":"ExNominatim.Client.new/3","type":"function"},{"doc":"Use the `/reverse` API endpoint. Delegated to from `ExNominatim.reverse/1`, which is documented.","ref":"ExNominatim.Client.html#reverse/1","title":"ExNominatim.Client.reverse/1","type":"function"},{"doc":"Use the `/search` API endpoint. Delegated to from `ExNominatim.search/1`, which is documented.","ref":"ExNominatim.Client.html#search/1","title":"ExNominatim.Client.search/1","type":"function"},{"doc":"Use the `/status` API endpoint. Delegated to from `ExNominatim.status/1`, which is documented.","ref":"ExNominatim.Client.html#status/1","title":"ExNominatim.Client.status/1","type":"function"},{"doc":"The struct for a request to the `/details` API endpoint.","ref":"ExNominatim.Client.DetailsParams.html","title":"ExNominatim.Client.DetailsParams","type":"module"},{"doc":"Construct a new `%DetailsParams{}` struct from the content of the keyword list `opts`.","ref":"ExNominatim.Client.DetailsParams.html#new/1","title":"ExNominatim.Client.DetailsParams.new/1","type":"function"},{"doc":"The struct for a request to the `/lookup` API endpoint.","ref":"ExNominatim.Client.LookupParams.html","title":"ExNominatim.Client.LookupParams","type":"module"},{"doc":"Construct a new `%LookupParams{}` struct from the content of the keyword list `opts`, while taking into account the required field (`:osm_ids`) for a request to the `/lookup` API endpoint.","ref":"ExNominatim.Client.LookupParams.html#new/1","title":"ExNominatim.Client.LookupParams.new/1","type":"function"},{"doc":"The struct for a request to the `/reverse` API endpoint.","ref":"ExNominatim.Client.ReverseParams.html","title":"ExNominatim.Client.ReverseParams","type":"module"},{"doc":"Construct a new `%ReverseParams{}` struct from the content of the keyword list `opts`, while taking into account the required fields (`:lat` and `:lon`) for a request to the `/reverse` API endpoint.","ref":"ExNominatim.Client.ReverseParams.html#new/1","title":"ExNominatim.Client.ReverseParams.new/1","type":"function"},{"doc":"The struct for a request to the `/search` API endpoint.","ref":"ExNominatim.Client.SearchParams.html","title":"ExNominatim.Client.SearchParams","type":"module"},{"doc":"Construct a new `%SearchParams{}` struct from the content of the keyword list `opts`, while taking into account that a request to the `/reverse` API endpoint requires either a free-form query with the keyword `:q` assigned a value _or_ a structured query with values defined for at least one of `:amenity`, `:street`, `:city`, `:county`, `:state`, `:country` and `:postalcode`, but not both.","ref":"ExNominatim.Client.SearchParams.html#new/1","title":"ExNominatim.Client.SearchParams.new/1","type":"function"},{"doc":"The struct for a request to the `/status` API endpoint.","ref":"ExNominatim.Client.StatusParams.html","title":"ExNominatim.Client.StatusParams","type":"module"},{"doc":"Construct a new `%StatusParams{}` struct from the content of the keyword list `opts`.","ref":"ExNominatim.Client.StatusParams.html#new/1","title":"ExNominatim.Client.StatusParams.new/1","type":"function"},{"doc":"Functions that prepare an HTTP request, including validating the base URL of the target Nominatim API server setting the User-Agent header automatically, and selecting all the non-nil request parameters.","ref":"ExNominatim.HTTP.html","title":"ExNominatim.HTTP","type":"module"},{"doc":"Prepares an HTTP request to the `endpoint` at `base_url` with the `params` map containing request parameters.\n\n* `endpoint` is one of `:search`, `:reverse`, `:lookup`, `:status`, `:details`.\n* `params` is a map (not a keyword list!) with the request parameters.\n* `base_url` is the the base URL of the target Nominatim API server.\n\nYou can use this function directly if you want to bypass the more user-friendly delegate functions in the main ExNominatim module and define the `params` map directly. This function does not perform any validation of the validity of the keys in `params` for the selected endpoint, or of their respective values vs. the API endpoint's specification.","ref":"ExNominatim.HTTP.html#prepare/3","title":"ExNominatim.HTTP.prepare/3","type":"function"},{"doc":"Functions used for the automatic validation of the keys of a request parameters struct according to the target endpoint, their values according to the API endpoint's specification, and invalidate any request parameters with confusing intent that might have unexpected results, such as defining both the `:q` free-form query parameter and at least one of the parameters of a structured query (`:city`, `:country`, etc.).","ref":"ExNominatim.Validations.html","title":"ExNominatim.Validations","type":"module"},{"doc":"Given a request params struct (`%ReverseParams{}`, `%SearchParams{}`, etc.) explain its fields, their default values (if any) and their values' limits (if applicable).","ref":"ExNominatim.Validations.html#explain_fields/1","title":"ExNominatim.Validations.explain_fields/1","type":"function"},{"doc":"Sanitizes the values of those fields of the `params` request params struct (`%SearchParams{}`, `%ReverseParams{}`, etc.) that contain a comma-separated list of strings according to the Nominatim API specification. It collapses all spaces and trims and leading and trailing commas.\n\nYou can use this function directly if you want to combine it with `ExNominatim.Validations.validate/1`.","ref":"ExNominatim.Validations.html#sanitize_comma_separated_strings/1","title":"ExNominatim.Validations.sanitize_comma_separated_strings/1","type":"function"},{"doc":"Validates the content and intent of a request represented by a request parameters struct `params` (`%SearchParams{}`, `%ReverseParams{}`, etc.).\n\nYou can use this function directly if you want to combine it with `ExNominatim.HTTP.prepare/3`.","ref":"ExNominatim.Validations.html#validate/1","title":"ExNominatim.Validations.validate/1","type":"function"},{"doc":"# ExNominatim\n\nExNominatim is a full-featured client for the [OpenStreetMap](https://www.openstreetmap.org) [Nominatim API V1](https://nominatim.org/release-docs/latest/api/Overview/), with extensive request validation, robust error-handling and reporting, and user guidance with helpful validation messages.","ref":"readme.html","title":"README","type":"extras"},{"doc":"* Prevent unnecessary calls to the Nominatim API server by validating intended requests and preventing them if the request parameters are invalid.\n* Solid error-handling for robustness in production.\n* Provide helpful validation messages to the user when a request is deemed invalid.","ref":"readme.html#goals","title":"Goals - README","type":"extras"},{"doc":"* Covers the `/search`, `/reverse`, `/lookup`, `/status` and `/details` endpoints.\n* Utilizes request parameter structs with the appropriate fields (except for `json_callback`) for each endpoint.\n* Validates parameter values prior to the request (possible to override this with the `force: true` option).\n* Provides helpful return tuples `{:ok, ...}`, `{:error, reason}` and `{:error, {specific_error, other_info}}` across the board.\n* Collects all detected field validation errors in an `:errors` field, and provides a `:valid?` field in each request params struct.\n* Can be used with self-hosted Nominatim API instances by setting the `:base_url` option of the enpoint-related functions in the `ExNominatim` module.\n* Automatically sets the `User-Agent` header to \"ExNominatim\" (plus the version) to comply with the [Nominatim Usage Policy](https://operations.osmfoundation.org/policies/nominatim/).","ref":"readme.html#features","title":"Features - README","type":"extras"},{"doc":"* Add a `Processing` module to automatically report back results as the content of the `%Req.Response{}` struct's `:body` together with the HTTP status.\n* Build [Cachex](https://hexdocs.pm/cachex/Cachex.html) in (see [Reactive Warming](https://hexdocs.pm/cachex/reactive-warming.html)) and provide the option to automatically throttle requests to the public API to the \"absolute maximum of 1 request per second\" as requested by the [Nominatim Usage Policy](https://operations.osmfoundation.org/policies/nominatim/).\n* Implement a test suite.","ref":"readme.html#ideas-and-someday-maybe-features","title":"Ideas and someday/maybe features - README","type":"extras"},{"doc":"The package can be installed [from Hex](https://hex.pm/package/ex_nominatim) by adding `ex_nominatim` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_nominatim, \"~> 1.0.0\"}\n  ]\nend\n```\n\nDocumentation has been published on [HexDocs](https://hexdocs.pm/ex_nominatim).","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"Copyright 2024, Made by [Isaak Tsalicoglou](https://linkedin.com/in/tisaak), [OVERBRING](https://overbring.com) in [Athens](https://www.openstreetmap.org/#map=11/37.9909/23.7387), [Attica](https://www.openstreetmap.org/#map=8/37.061/23.456), [Greece](https://www.openstreetmap.org/#map=6/38.310/24.489).\n\nMany thanks to all the volunteers and contributors of [OpenStreetMap](https://www.openstreetmap.org/) and [Nominatim](https://nominatim.org/).","ref":"readme.html#who-made-this","title":"Who made this? - README","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}